"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$literal = exports.lNumber = exports.lBoolean = exports.lUndefined = exports.lNull = void 0;
const pierrejs_1 = require("pierrejs");
const string_1 = require("./string");
exports.lNull = pierrejs_1.default.string('null')
    .map(() => null)
    .withName('null');
exports.lUndefined = pierrejs_1.default.string('undefined')
    .map(() => void 0)
    .withName('undefined');
exports.lBoolean = pierrejs_1.default.oneOf(pierrejs_1.default.string('true'), pierrejs_1.default.string('false'))
    .map(s => s === 'true')
    .withName('boolean');
exports.lNumber = pierrejs_1.default.regex('number', /^[+\-]?[0-9]+(\.[0-9]+)?/)
    .map(n => Number(n));
exports.$literal = pierrejs_1.default.either(exports.lNull, exports.lUndefined, exports.lBoolean, exports.lNumber, string_1.lString)
    .map((value) => ({ type: 'LITERAL', value }))
    .withName('literal');
