"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Execution = void 0;
class Execution {
    constructor(contexts, extraHelpers) {
        this.contexts = contexts;
        this.extraHelpers = extraHelpers;
    }
    get context() {
        return this.contexts[this.contexts.length - 1];
    }
    withChildContext(context) {
        return new Execution([...this.contexts, context], this.extraHelpers);
    }
    static of(context, extraHelpers = new Map()) {
        return new Execution([context], extraHelpers);
    }
}
exports.Execution = Execution;
